import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;

public class FireballShooting{
  static Color BALL_COLOR = Color.red;
  static Color EXPLOSION_COLOR = new Color(255, 255, 100);
  static Color SPACE_COLOR = Color.black;
  int x, y, e, highScore;
  GamePanel gp;
  Random rand;
  int baseDiameter = 15; //΂̋ʂ̒a
  JFrame frame;
  JTextField tf;
  JLabel label;

  public FireballShooting(){

    JPanel p = new JPanel(); //XRA{[hpRei
    p.setLayout(new GridLayout(1, 2));
    label = new JLabel("Score: ");
    label.setHorizontalAlignment(JLabel.RIGHT);
    tf = new JTextField();
    tf.setHorizontalAlignment(JTextField.RIGHT);
    tf.setText("0");
    p.add(label);
    p.add(tf);

    gp = new GamePanel(this); //΂̋ʕ\pl
    gp.setBackground(SPACE_COLOR);

    rand = new Random();
    highScore = readCurrentHighScore(); //܂ł̃nCXRAǂށij

    frame = new JFrame("΂̋ʂāI");
    frame.addWindowListener(new WindowAdapter(){ //̓NX

      public void windowClosing(WindowEvent we){ //EBhEƂ̏

        updateHighScore(); //nCXRAL^XVij
        System.exit(0); //I
      }
    });

    Thread t = new Thread(){ //Q[isW̃Xbh

      public void run(){ //Xbh̎s{̂͂˂run()\bh
        int temp, period;

        while (true){ //[v
          period = rand.nextInt(1000) + 1000;
          e = rand.nextInt(8); // 0 - 7 ...΂̋ʂ̃TCYω
          temp = 500 - (baseDiameter + e) * 2;
          x = rand.nextInt(temp); //oʒu
          y = rand.nextInt(temp);
          gp.setColor(BALL_COLOR);
          gp.repaintBall(x, y, e); //΂̋ʂ`
          try{
            Thread.currentThread().sleep(period); //P`Qb̊Ԋu
          }
          catch (InterruptedException ie){
            ie.printStackTrace();
          }
        }
      }
    };

    Container con = frame.getContentPane();
    con.add(gp, BorderLayout.CENTER);
    con.add(p, BorderLayout.SOUTH);

    frame.setBounds(0, 0, 500, 550);
    frame.setVisible(true);
    t.start(); //Q[isWX^[g
  }

  /* t@C猻݂܂ł̃nCXRAlǂ */
  int readCurrentHighScore(){
    //
    return 0; //̒l
  }

  /* nCXRAt@CXV */
  void updateHighScore(){
    //
  }

  public static void main(String[] args){

    new FireballShooting();
  }
}

/*_ɉ΂̋ʂ\邽߂̃pl*/
class GamePanel extends JPanel{
  FireballShooting fs;
  int diam, x, y, e, score;
  Ellipse2D.Float ball;
  Color color;

  public GamePanel(FireballShooting f){

    fs = f;
    score = 0;
    diam = fs.baseDiameter;
    ball = new Ellipse2D.Float(); //ꂪ΂̋ʂI
    color = FireballShooting.BALL_COLOR;
    addMouseListener(new HitListener(this, fs.tf)); //}EXXio^
  }

  public void paintComponent(Graphics g){

    super.paintComponent(g);

    Graphics2D g2 = (Graphics2D)g;
    g2.setColor(color);
    float sizex = (float)(diam + e);
    float sizey = sizex;
    if (color == FireballShooting.EXPLOSION_COLOR){
      sizex = sizex * 2.0F; //̃TCY
      sizey = sizey * 0.7F;
    }
    ball.setFrame((float)x, (float)y, sizex, sizey);
    g2.fill(ball);
  }

  public int getScore(){

    return score;
  }

  public void setScore(int scr){

    score = scr;
  }

  public Color getColor(){

    return color;
  }
  
  public void setColor(Color c){

    color = c;
  }

  public void repaintBall(int newX, int newY, int newE){

    x = newX;
    y = newY;
    e = newE;
    repaint();
  }
}

/*}EXɂgˌh̖𔻒肷*/
class HitListener extends MouseAdapter{
  GamePanel gp;
  JTextField scoreBoard;
  AudioClip ac;

  public HitListener(GamePanel p, JTextField jtf){
    URL url = null;

    try{  //URL͊e̊ɍ킹ďĂ
      url = new URL("file:///root/explosion.wav"); //̃t@C
    }
    catch (Exception e){
      e.printStackTrace();
    }
    ac = Applet.newAudioClip(url);
    gp = p;
    scoreBoard = jtf;
  }

  public void mouseClicked(MouseEvent me){
    int sc;

    int x = me.getX();
    int y = me.getY();

    if (gp.ball.contains(new Point2D.Float((float)x, (float)y))){ //Ȃc
      ac.play(); //
      gp.setScore(sc = gp.getScore() + 10); //XRA𑝂₵
      scoreBoard.setText("" + sc); //XRA{[h
      gp.setColor(FireballShooting.EXPLOSION_COLOR); //F
      gp.repaint();
    }
  }
}
