import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class GuiAndThreadA{
  JFrame frame;
  Container con;
  JPanel buttonPanel;
  JButton color,work;

  public GuiAndThreadA(){

    frame = new JFrame();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    con = frame.getContentPane();

    color = new JButton("wiFς");
    work = new JButton("dJn");
    ButtonListenerA btl = new ButtonListenerA(this);
    color.addActionListener(btl);
    work.addActionListener(btl);

    buttonPanel = new JPanel(new GridLayout(1, 2));
    buttonPanel.add(color);
    buttonPanel.add(work);

    con.add(buttonPanel, BorderLayout.SOUTH);
    con.setBackground(Color.green);
    
    frame.setSize(300, 300);
    frame.setVisible(true);
  }

  public static void main(String[] args){

    new GuiAndThreadA();
  }
}

class ButtonListenerA implements ActionListener{
  GuiAndThreadA ga;

  public ButtonListenerA(GuiAndThreadA g){

    ga = g;
  }

  public void actionPerformed(ActionEvent ae){

    JButton b = (JButton)(ae.getSource());
    String s = b.getText();

    if (s.equals("wiFς")){
      Color c = ga.con.getBackground();
      if (c.equals(Color.green)){
        ga.con.setBackground(Color.red);
      }
      else{
        ga.con.setBackground(Color.green);
      }
    }
    else if (s.equals("dJn")){
      b.setText("dc");
      doLongWork(b);
      b.setText("dI܂");
    }
  }

  void doLongWork(JButton btn){
    int counter = 10;

    while (counter-- > 0){
      try{
        Thread.sleep(1000); //Pb
      }
      catch (InterruptedException ie){
        ie.printStackTrace();
      }
      btn.setText("dccF" + counter); //i
    }
  }
}



