import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class SpinnerDemo{
  static final String[] meals
   = {"ց", "", "p", "XpQeB", "Ă", "|eg",
     "i", "ց"};
  static final String[] soups
   = {"", "݂`", "|^[W", "~lXg[l", "񂽂",
     "R\", "J[",""};
  JFrame frame;
  JSpinner spinner;
  SpinnerListModel model;
  JLabel labela, labelb;
  HashMap hmap;

  public SpinnerDemo(){

    frame = new JFrame("SpinnerDemo");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    Container conp = frame.getContentPane();
    conp.setLayout(new GridLayout(0, 1)); //0

    labela = new JLabel("HIł");
    labela.setHorizontalAlignment(JLabel.CENTER);
    labelb = new JLabel("[܂܂Ă܂]");
    labelb.setHorizontalAlignment(JLabel.CENTER);
    model = new SpinnerListModel(meals);
    spinner = new JSpinner(model);

    Container cont = (Container)(spinner.getComponent(2)); //JPanel
    Component comp = cont.getComponent(0); //JFormattedTextField
    JTextField tf = (JTextField)comp;
    tf.setHorizontalAlignment(JTextField.CENTER); //肽߂ɂ̂SsI

    conp.add(labela);
    conp.add(spinner);
    conp.add(labelb);

    hmap = new HashMap(); //f[^\
    for (int i = 0; i < meals.length; ++i){
      hmap.put(meals[i], soups[i]);
    }

    frame.setBounds(0, 0, 300, 150);
    frame.setVisible(true);

    spinner.addChangeListener(new SpinnerListener(labelb, hmap));
  }

  public static void main(String[] args){

    new SpinnerDemo();
  }
}

/* Xsî߂̃CxgXi */
class SpinnerListener implements ChangeListener{
  JLabel lab;
  HashMap data;
  
  public SpinnerListener(JLabel la, HashMap m){

    lab = la;
    data = m;
  }

  public void stateChanged(ChangeEvent ce){
    String ms, ss;

    JSpinner spin = (JSpinner)(ce.getSource());

    try{
      spin.commitEdit();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    ss = (String)(spin.getValue());
    ms = (String)(data.get(ss));
    lab.setText(ms);
  }
}
