import java.io.*;
import java.math.*;

public class YenToDollar{
  BigDecimal dollar, yen, rate;
  String yenString, dollarString, rateString;
  static String infName = "yen.txt";
  static String oufName = "dollar.txt";
  static String digits = "0123456789";

  public YenToDollar(String ys, String rs){

    yenString = ys;
    rateString = rs;
    yen = new BigDecimal(yenString);
    rate = new BigDecimal(rateString);
    dollar = convert(yen, rate);
    dollarString = dollar.toString();
  }

  public BigDecimal convert(BigDecimal y, BigDecimal r){
                             //_ȉQ
    BigDecimal d = y.divide(r, 2, BigDecimal.ROUND_HALF_UP); //ľܓ
    return d;
  }

  public String getDollarString(){

    return dollarString;
  }

  public static void main(String[] args){
    String line, yenStr, dolStr, rateStr;

    line = yenStr = dolStr = null; //v
    rateStr = "105.40"; // 2004/12/20ij
    if (args.length > 0){
      rateStr = args[0]; //R}hC
    }
    try{
      BufferedReader br = new BufferedReader(new FileReader(infName));
      PrintWriter pw
       = new PrintWriter(new BufferedWriter(new FileWriter(oufName)));

      while ((line = br.readLine()) != null){ //t@C̏IɒB܂
        int startDigit = getStartDigit(line);  //l̂͂܂
        int endDigit = getEndDigit(line);      //l̂̒
        yenStr = line.substring(startDigit, endDigit); //zl̂

        YenToDollar ytd = new YenToDollar(yenStr, rateStr);
        dolStr = ytd.getDollarString();
        line = line.replaceAll(yenStr + "~", dolStr + "h");

        pw.println(line); //ϊʂso
      }
      br.close();
      pw.close();
    }
    catch (Exception e){
      e.printStackTrace();
    }
  }

  /* ŏ̐̈ʒuԂ */
  public static int getStartDigit(String s){
    int r = -1;

    for (int i = 0; i < s.length(); ++i){
      if (digits.indexOf(s.charAt(i)) != -1){ //pASCII
        r = i;
        break; //[vʂ
      }
    }
    return r;
  }

  /* Ō̐̒̈ʒuԂ */
  public static int getEndDigit(String s){
    int r = -1;

    int i = getStartDigit(s); //̍ŏ
    if (i != -1){ //
      while (++i < s.length()){
        if (digits.indexOf(s.charAt(i)) == -1){ //łȂ
          break;
        }
      }
      r = i;
    }
    return r;
  }
}
