import javax.swing.*;
import java.awt.*;

public class ZebraList extends JList{

  public ListCellRenderer getCellRenderer(){

    return new ZebraListCellRenderer();
  }

  public java.awt.Color getSelectionForeground(){

    return Color.black;
  }

  public java.awt.Color getSelectionBackground(){

    return new Color(255, 220, 100); //邢IW
  }

  /*eXgpmain()\bh*/
  public static void main(String[] args){
    JList list;
    String[] data = {"`[n", "Jc", "Ђ", "eq", "st",
      "J[CX", "nVCX", "炵i", "ICX", "h[A"};

    list = new ZebraList();
    list.setListData(data);
    JPanel panel = new JPanel();
    panel.setBackground(Color.blue);
    panel.add(list);

    JFrame frame = new JFrame("ZebraList Test");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.getContentPane().add(panel, BorderLayout.CENTER);

    frame.setBounds(0, 0, 150, 250);
    frame.setVisible(true);
  }
}

class ZebraListCellRenderer extends DefaultListCellRenderer{

  public Component getListCellRendererComponent(JList list, Object value,
   int index, boolean isSelected, boolean cellHasFocus){
    Color b, f;

    /*{IȂƁi\Ȃǁj̓X[p[NXɂĂ炤*/
    super.getListCellRendererComponent
     (list, value, index, isSelected, cellHasFocus);
    
    b = f = null;
    if (isSelected){
      b = list.getSelectionBackground();
      f = list.getSelectionForeground();
    }
    else if (index % 2 == 0){ //index 0, 2, 4, ...
      b = Color.pink;
    }
    else{                     // 1, 3, 5, ...
      b = Color.cyan;
    }
    setBackground(b);
    if (f != null){
      setForeground(f);
    }
    return this;
  }
}

