import java.io.*;
import java.util.*;
import java.util.regex.*;

public class GetLinks{
  static final String linkPattern = "href=([^?> ]+)[?> ]";
  String fileName;
  String fileContent;
  ArrayList ar;

  public GetLinks(String fnam){
    String line = null;

    fileName = fnam;
    StringBuffer sb = new StringBuffer();
    ar = new ArrayList();
    
    try{
     BufferedReader br = new BufferedReader(new FileReader(fileName));
     while ((line = br.readLine()) != null){
       sb.append(line);
     }
    }
    catch (Exception e){
      e.printStackTrace();
    }
    fileContent = new String(sb);
//System.out.println(fileContent);

    Pattern pat = Pattern.compile(linkPattern, Pattern.CASE_INSENSITIVE);
    Matcher mat = pat.matcher(fileContent);
    while (mat.find()){
      line = mat.group(1);
      if (line != null && line.length() > 0){
//System.out.println("R:" + line);
        line = deQuote(line);
        if (line.length() > 0){
          ar.add(line);
        }
      }
    }
  }

  /* p */
  String deQuote(String s){
    int b = 0;
    int e = s.length();
    char ch;

    ch = s.charAt(0);
    if (ch == '\'' || ch == '"'){
      ++b;
    }
    ch = s.charAt(s.length() - 1); //Ō̕
    if (ch == '\'' || ch == '"'){
      --e;
    }
    return s.substring(b, e);
  }
    
  
  public ArrayList getLinks(){
    return ar;
  }

  /* eXgpmain()\bh */
  public static void main(String[] args){
    String fn;
    ArrayList result;
    
    fn = "test.html";
    if (args.length > 0){
      fn = args[0]; //R}hCŃt@Cw
    }

    GetLinks gl = new GetLinks(fn);
    result = gl.getLinks();

    Iterator it = result.iterator();
    while (it.hasNext()){
      System.out.println((String)(it.next()));
    }
  }
}


