import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class GuiAndThreadB{
  JFrame frame;
  Container con;
  JPanel buttonPanel;
  JButton color,work;

  public GuiAndThreadB(){

    frame = new JFrame();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    con = frame.getContentPane();

    color = new JButton("wiFς");
    work = new JButton("dJn");
    ButtonListenerB btl = new ButtonListenerB(this);
    color.addActionListener(btl);
    work.addActionListener(btl);

    buttonPanel = new JPanel(new GridLayout(1, 2));
    buttonPanel.add(color);
    buttonPanel.add(work);

    con.add(buttonPanel, BorderLayout.SOUTH);
    con.setBackground(Color.green);
    
    frame.setSize(300, 300);
    frame.setVisible(true);
  }

  public static void main(String[] args){

    new GuiAndThreadB();
  }
}

class ButtonListenerB implements ActionListener{
  GuiAndThreadB ga;

  public ButtonListenerB(GuiAndThreadB g){

    ga = g;
  }

  public void actionPerformed(ActionEvent ae){

    JButton b = (JButton)(ae.getSource());
    String s = b.getText();

    if (s.equals("wiFς")){
      Color c = ga.con.getBackground();
      if (c.equals(Color.green)){
        ga.con.setBackground(Color.red);
      }
      else{
        ga.con.setBackground(Color.green);
      }
    }
    else if (s.equals("dJn")){
      b.setText("dc");
      doLongWork(b);
    }
  }

  /*Ԃ̂d*/
  void doLongWork(JButton bt){

    LongWork longw = new LongWork(bt); //ʃXbhɂ点
    longw.start();
  }
}

/*ʃXbhGUIXVɂinvokeLater()Ȃǂg*/
class LongWork extends Thread{
  JButton btn;
  int counter;
  Runnable r, e;  

  public LongWork(JButton but){

    btn = but;
    counter = 10;

    r = new Runnable(){
      public void run(){
        btn.setText("dccF" + counter);
      }
    };

    e = new Runnable(){
      public void run(){
        btn.setText("dI܂");
      }
    };
  }

  public void run(){

    while (counter-- > 0){
      try{
        Thread.sleep(1000); //Pb
        SwingUtilities.invokeAndWait(r); //i
      }
      catch (Exception e){
        e.printStackTrace();
      }
    }
    SwingUtilities.invokeLater(e); //I
  }
}
