import javax.swing.*;
import java.awt.*;

public class Tabbed{
  JFrame frame;
  JPanel p1, p2, p3;
  JTabbedPane jtp;

  public Tabbed(){

    frame = new JFrame("JTabbedPane Test");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    jtp = new JTabbedPane(JTabbedPane.TOP);

    p1 = new JPanel(new GridLayout(3, 1));
    p2 = new JPanel(new GridLayout(2, 2));
    p3 = new JPanel(new FlowLayout(FlowLayout.CENTER));

    p1.add(new JLabel("Bottom1"));
    p1.add(new JLabel("Bottom2"));
    p1.add(new JLabel("Bottom3"));

    p2.add(new JTextField("Middle 1"));
    p2.add(new JTextField("Middle 2"));
    p2.add(new JTextField("Middle 3"));
    p2.add(new JTextField("Middle 4"));

    for (int i = 1; i <= 5; ++i){
      p3.add(new JButton("Top " + i));
    }

    p1.setBorder(BorderFactory.createLineBorder(Color.red, 3));
    p2.setBorder(BorderFactory.createLineBorder(Color.green, 3));
    p3.setBorder(BorderFactory.createLineBorder(Color.blue, 3));

    jtp.add("x", p1);
    jtp.add("eLXg", p2);
    jtp.add("{^", p3);

    frame.getContentPane().add(jtp);
    frame.setSize(300, 350);
    frame.setVisible(true);
  }

  public static void main(String[] args){

    new Tabbed();
  }
}
